/*
 * Copyright (c) 2017 Brook Milligan.
 *
 * This file is part of the GraphModel Library.
 *
 *     The GraphModel Library is free software: you can redistribute
 *     it and/or modify it under the terms of the GNU Affero General
 *     Public License as published by the Free Software Foundation,
 *     either version 3 of the License, or (at your option) any later
 *     version.
 *
 *     The GraphModel Library is distributed in the hope that it will
 *     be useful, but WITHOUT ANY WARRANTY; without even the implied
 *     warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR
 *     PURPOSE.  See the GNU Affero General Public License for more
 *     details.
 *
 *     You should have received a copy of the GNU Affero General
 *     Public License along with the GraphModel Library.  If not, see
 *     <http://www.gnu.org/licenses/>.
 */

/// \file

#ifndef GRAPH_MODEL_CONCEPT_FACTOR_POLICY_CONCEPT_HPP
#define GRAPH_MODEL_CONCEPT_FACTOR_POLICY_CONCEPT_HPP 1

#include <graph_model/concept/pdf_policy_concept.hpp>
#include <graph_model/concept/policy_concept.hpp>
#include <graph_model/concept/probability_archetype.hpp>

namespace graph_model
{

  namespace concept
  {

    template < typename T
	       , typename Probability = probability_archetype<>
	       >
    struct factor_policy_concept
      : policy_concept<T>
      , pdf_policy_concept<T,Probability>
    {};

  } // namespace concept

} // namespace graph_model

#endif
