/*
 * Copyright (c) 2016,2017 Brook Milligan.
 *
 * This file is part of the GraphModel Library.
 *
 *     The GraphModel Library is free software: you can redistribute
 *     it and/or modify it under the terms of the GNU Affero General
 *     Public License as published by the Free Software Foundation,
 *     either version 3 of the License, or (at your option) any later
 *     version.
 *
 *     The GraphModel Library is distributed in the hope that it will
 *     be useful, but WITHOUT ANY WARRANTY; without even the implied
 *     warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR
 *     PURPOSE.  See the GNU Affero General Public License for more
 *     details.
 *
 *     You should have received a copy of the GNU Affero General
 *     Public License along with the GraphModel Library.  If not, see
 *     <http://www.gnu.org/licenses/>.
 */

/// \file

#ifndef GRAPH_MODEL_VERTEX_PARAMETER_TAGS_HPP
#define GRAPH_MODEL_VERTEX_PARAMETER_TAGS_HPP 1

#include <iostream>
#include <graph_model/vertex/tags.hpp>

namespace graph_model
{

  namespace vertex
  {

    namespace tag
    {

      struct unknown {};

      struct variate {};

      struct mean {};
      struct variance {};
      struct standard_deviation {};
      struct precision {};

#define STREAMABLE_TAG(Tag)				\
      std::ostream& operator << (std::ostream& os, Tag) \
      { return os << #Tag; }				\
      /**/

#undef STREAMABLE_TAG

    } // namespace tag

  } // namespace vertex

} // namespace graph_model

#endif
