/*
 * Copyright (c) 2017 Brook Milligan.
 *
 * This file is part of the GraphModel Library.
 *
 *     The GraphModel Library is free software: you can redistribute
 *     it and/or modify it under the terms of the GNU Affero General
 *     Public License as published by the Free Software Foundation,
 *     either version 3 of the License, or (at your option) any later
 *     version.
 *
 *     The GraphModel Library is distributed in the hope that it will
 *     be useful, but WITHOUT ANY WARRANTY; without even the implied
 *     warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR
 *     PURPOSE.  See the GNU Affero General Public License for more
 *     details.
 *
 *     You should have received a copy of the GNU Affero General
 *     Public License along with the GraphModel Library.  If not, see
 *     <http://www.gnu.org/licenses/>.
 */

/// \file

#ifndef GRAPH_MODEL_VERTEX_VERTEX_CATEGORY_BASE_HPP
#define GRAPH_MODEL_VERTEX_VERTEX_CATEGORY_BASE_HPP 1

#include <graph_model/vertex/type/vertex_category_base.hpp>
#include <use_default.hpp>

namespace graph_model
{

  namespace vertex
  {

    template < typename VertexCategory = use_default<> >
    class vertex_category_base
      : public virtual type::vertex_category_base<VertexCategory>
    {
      using base = type::vertex_category_base<VertexCategory>;
      using vertex_category_type = typename base::vertex_category_type;

    public:
      vertex_category_base () = default;

      template < typename Category >
      vertex_category_base (Category category)
	: vertex_category_(category)
      {}

      auto vertex_category () const { return vertex_category_; }

    private:
      vertex_category_type vertex_category_;
    };

  } // namespace vertex

} // namespace graph_model

#endif
